/*************************************\
| MLC AFX by Jacek (4nic8) Malinowski |
+-------------------------------------+
| contact: 4nic8@casiocalc.org        |
\*************************************/


//#include <conio.h>
#include <stdlib.h>

//#include <dos.h>

#include "libs\utils.c"

#include "libs\gxlib10.h"
#include "libs\gxlib10.c"
#include "libs\gxlibcod.c"

#define VXS 0
#define VXM 128

#include "libs\gx_plug.c"

#include "libs\font_gx.c"

#include "libs\testkey.c"

#include "abc.c"
//#include "f_bfont.c"

#include "Memzones.c"
//#include "mzlist.c"

#include "mlc.h"

uchar scr_b123[3][1024];

//#define DEBUG1
//#define DEBUG2
//#define DEBUG3
//#define DEBUG4

//#define DEBUG_MEM

//#define DEBUG5

void halt();
void close_go_menu();

unsigned char name[20];/* Name of MLC file */
uchar far *code;/* pointer to MLC tokenized code */
uchar far *source;/* pointer to MLC source */
uchar far *mlc_save;
uint code_size; /* size of MLC file */

uchar over=0; /* when over==1 MLC program stops*/

void set_go_menu();

#include "token.c"
#include "interpr.c"

//#include "shell.c"

#if defined DEBUG3
	char key=0;
	uint pom;
	syntax syx;
#endif

void halt(){
	over=1;	
}


#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

void menu(){
	close_go_menu();
	halt();
}

void interrupt ( *oldhandler)(__CPPARGS);

void interrupt handler(__CPPARGS)
{
	static bool key=false;
	oldhandler(); 
	if (testkey(K_AC))
		over=1;//menu();
	if(testkey(K_F)) { if(!key) { contplus(); key = true; } }
		else if(testkey(K_L)) { if(!key) { contmoins(); key = true; } }
		else key=false;
    
}
void set_go_menu(){
	setvect(0x1C, handler);	
}

void old_int(){
	oldhandler = getvect(0x1C);
}

void close_go_menu(){
	setvect(0x1C, oldhandler);	
}


uint free_m(){
	uint fmem;
	asm{
		push ax
		push bx
		mov bx,0xafff
		mov ax,0x48
		int 0x21
		mov fmem,bx
		pop ax
		pop bx
	}
	return fmem;
}

void main(int argc, char **argv){	
	
	uint tok_size;	
	struct memory_zone fp_c,fp_t;
	int i,ix;			
	struct memory_zone fp_sv;
	char sv_name[20];
#if defined DEBUG_MEM
	clrscr();
	 printf("The difference between the highest allocated block and\n");
	 printf("the top of the heap is: %u bytes\n", (unsigned) coreleft());
	//printf("Free : %ub",allocmem(0xafff,pcode));
	if (getch()==0) getch();
#endif

#if !defined DEBUG4 && !defined DEBUG_MEM
		inter(0);
		gxSetMode(true);		
#endif
	
	memcpy(name,argv[1],9);
	old_int();
	set_go_menu();
    sv_name[0]='~';
			for (i=1;i<20;i++) sv_name[i]=name[i-1];
			sv_name[8]='\0';
			if (search_mem_zone(1,sv_name,&fp_sv)==-1) 
				create_mem_zone(1,sv_name,MLC_SAVE_FILE,CREATE_ZONE);

			if (search_mem_zone(1,name,&fp_c)!=-1) 
			{		
				/* tokenized file */
				if (search_mem_zone(1,TEMP_FILE,&fp_t)!=-1) 
				{
					create_mem_zone(1,TEMP_FILE,fp_t.b_size,DELETE_ZONE);
				}
				create_mem_zone(1,TEMP_FILE,fp_c.b_size,CREATE_ZONE);
				if (search_mem_zone(1,TEMP_FILE,&fp_t)==-1) error_msg2("Out of RAM memory","");		
				
				/* pointer to tokenized code */
				code = (unsigned char far *) MK_FP(fp_t.b_segment,fp_t.b_offset+21);
				
				code_size=(uint)fp_c.b_size-24;
				search_mem_zone(1,name,&fp_c);
				/* pointer to source code */
				source = (unsigned char far *) MK_FP(fp_c.b_segment,fp_c.b_offset+21);

				if (search_mem_zone(1,sv_name,&fp_sv)==-1) error_msg2("Out of RAM memory","");		
				change_password(&fp_sv,"mlcsave");
				/* pointer to save file code */
				mlc_save = (unsigned char far *) MK_FP(fp_sv.b_segment,fp_sv.b_offset+21);
				
				gxClearBuff();
				OutStrTI(1,1,"MLC Copyrights(c) 2004-2005",3,ti);
				OutStrTI(1,7,"Epic Programming Studio",3,ti);
				OutStrTI(1,13,"MLC AFX Copyrights(c) 2004-2005",3,ti);
				OutStrTI(1,19,"Jacek (4nic8) Maliniowski",3,ti);
				OutStrTI(1,30,"tokenizing... (v. 1.15)",2,ti);
				gxRefresh();
				tokenizer(fp_c.b_size-24,&tok_size);
		
				take_functions(tok_size);		
				gxClearBuff();
				gxRefresh();		
				
				start_inter();
				//read_f_list();
			}
			else
			{
				error_msg2(name,"No input file");
			}

	//run_shell(name);
	
	
}